/* atomic.h */

/*
 * Copyright 2007, 2008, 2009, 2010, 2011, 2012 by
 *	University of New Hampshire Interoperability Laboratory
 *	121 Technology Drive, Suite 2
 *	Durham, NH 03824-4716
 *	phone: 1-603-862-0090
 *	fax: 1-603-862-4181
 *	e-mail: info@iol.unh.edu
 * All rights reserved.
 *
 * This file is part of the UNH EXS implementation of the
 * Consortium Specification: Extended Sockets API (ES-API) Issue 1.0,
 * Document Number C050 published by The Open Group, January 2005,
 * and copyright 2005 by The Open Group.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING.GPL in the main directory of this source tree, or the
 * BSD license, available from the file COPYING.BSD in the main directory
 * of this source tree.
 *
 * This material is based upon work supported by the National Science
 * Foundation under Grant No. OCI-1127228.
 *
 * Any opinions, findings, and conclusions or recommendations
 * expressed in this material are those of the authors and do not
 * necessarily reflect the views of the National Science Foundation.
 */

#ifndef ATOMIC_H
#define ATOMIC_H

extern unsigned int
atomic_add_reset(unsigned int increment, unsigned int limit,
						volatile unsigned int *result);

extern int
atomic_set_bits(unsigned int mask, volatile unsigned int *result);

extern int
atomic_clear_bits(unsigned int mask, volatile unsigned int *result);

extern unsigned int
atomic_swap_if_match(unsigned int swap_value, unsigned int match_value,
						volatile unsigned int *result);

extern void *
atomic_swap_if_match_ptr(void *swap_value, void *match_value,
						volatile void **result);

#endif
/* vim: set shiftwidth=8 tabstop=8 noexpandtab : */
